#!/usr/bin/perl

require "config.pl";

if ($ENV{'REQUEST_METHOD'} eq "GET") {
 $buffer = $ENV{'QUERY_STRING'};
} 
elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
 read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
 ($name, $value) = split(/=/, $pair);
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $value =~ s/<([^>]|\n)*>//g;
 $value =~ s/<!--(.|\n)*-->//g;
 $value =~ s/\"/\'/g;
 $value =~ s/\|/\!/g;
 $FORM{$name} = $value;
}

&http_head;
&html_head;
$action = $FORM{'action'};
if ($action eq 'open') { &open; } #  
else { &show; } #  
&html_end;
exit;

sub adminform {
 $name = $FORM{'name'};
 print "<form method=post action=\"$adminname\">";
 print "<input type=hidden name=action value=admin>";
 print "<input type=hidden name=name value=$name>";
 print " : <input type=password name=password class=button size=10 maxlength=10>";
 print " <input type=submit class=button name=ok value=\"OK\"></form>";
}

sub superadmin {
 $name = $FORM{'name'};
 print "<form method=post action=\"$adminname\">";
 print "<input type=hidden name=action value=super>";
 print " : <input type=password name=password class=button size=10 maxlength=10>";
 print " <input type=submit class=button name=ok value=\"OK\"></form>";
}

sub show {
 open (DATA, $tabname);
 @data = <DATA>;
 close (DATA);
 if (@data) {
  &tab_start;
  print "      .   ,     ,  <a href=\"$helpname\" target=_blank>  </a>.";
  &tab_end;
  print "<center>";
  foreach $line(@data) {
   chomp($line);
   ($name, $resume) = split(/\|/, $line);
   print "<table border=0 width=$mainwidth>";
   print "<tr><td width=90% valign=top>$resume</td>";
   print "<td width=10%>";
   print "<form action=$cginame method=post>";
   print "<input type=hidden name=action value=open>";
   print "<input type=hidden name=name value=\"$name\">";
   print "<input type=submit class=button name=ok value=\"\">";
   print "</form>";
   &tab_end;
  }
  print "</center>";
 }
 else {
  &tab_start;
  print "         .      .";
  &tab_end;
 }
 &superadmin;
}

sub open {
 $name = $FORM{'name'};
 if ($FORM{'variant'} ne '') { $variant = $FORM{'variant'}; }
 else { $variant=-1; }

 open (FILE, "$datafolder/$name/$name.ip");
 @ips = <FILE>;
 close(FILE);

 $thisIP=$ENV{'REMOTE_ADDR'};
 $found=0;
 $i=0;
 $numplus=-1;
 if (@ips) {
  foreach $line (@ips) {
   chomp($line);
   ($ip, $num, $balls) = split(/\|/, $line);                
   if ($ip eq $thisIP) { 
    if ($variant != -1) {
     $num += 1;
    }
    $number=$num; 
    $found=1;
    $numplus=$i;
    $ball1=$balls;
   }
   $newip[$i]="$ip\|$num\|$balls\n"; 
   $i+=1;
  }
 }
 if ($found==0) {
  $newip[$i]="$thisIP\|0\|0\n";
  $number=0;
  $numplus=0;
 }
 $num1 = $number+1;

 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);

 $found=0;
 if (@data) {
  $count=0;
  $ball=0;
  for ($i=2; $i<=$#data; $i+=1) {
   chomp ($data[$i]);
   if ($data[$i] eq "") {
    if ($count == $number) {
     ($text,$picture,$vars)=split(/\|/, $data[$i+1]);
     print "<table border=0 width=$mainwidth>\n<tr><td height=$headheight colspan=2 nowrap><p><big><b>$num1. $text</b></big></p></td></tr>\n";
     if ($picture ne "") {
      print "<tr><td colspan=2><img src=\"$picpath/$name/$picture\" alt=\"$picture\"></td></tr>\n";
     }
     for ($j=0; $j<$vars; $j+=1) {
      ($text,$ball)=split(/\|/, $data[$i+2+$j]);
      print "<tr><td width=90%>$text</td><td width=10%>\n";
      print "<form action=$cginame method=post>\n";
      print "<input type=hidden name=action value=open>\n";
      print "<input type=hidden name=name value=\"$name\">\n";
      print "<input type=hidden name=variant value=\"$j\">\n";
      print "<input type=submit class=button name=ok value=\"\">\n";
      print "</form>\n";
     }
     &tab_end;
     $found=1;
     break;
    }
    elsif ($count == $number-1) { #    
     ($text,$picture,$vars)=split(/\|/, $data[$i+1]);
     if (($variant != -1) and (($variant<0) or ($variant>=$vars)) ) {
      &tab_start;
      print "<p>      $number    : <b>$variant</b>.      -  0  $vars.   .</p>";
      &tab_end;
      &linktoback;
      exit;
     }     
     $ball = 0;
     for ($j=0; $j<=$variant; $j+=1) {
      ($text,$ball)=split(/\|/, $data[$i+2+$j]);
     }
     $ball1 += $ball;
     $newip[$numplus]="$thisIP\|$number\|$ball1\n"; 
     ###
    }
    $count +=1;
   }
  }
 }
 else {
  &tab_start;
  print "<p>    !     <b>$name.txt</b>     $name    .   .</p>";
  &tab_end;
 } 
 &linktoback;
 open (FILE, ">$datafolder/$name/$name.ip");
 flock(FILE,2);
 truncate(FILE,0);
 print FILE @newip;
 flock(FILE,8);
 close(FILE);

 if ($found == 0) {
  &results;
 }
 &adminform;
}

sub results {
 $thisIP=$ENV{'REMOTE_ADDR'};
 $name = $FORM{'name'};
 open (FILE, "$datafolder/$name/$name.ip");
 @ips = <FILE>;
 close(FILE);
 $found=0;
 $max=0;
 foreach $line (@ips) {
  chomp($line);
  ($ip, $number, $balls) = split(/\|/, $line);                
  if ($ip eq $thisIP) { 
   $your = $balls;
   $found=1;
  }
  if ($balls > $max) { $max = $balls; }
 }
 if ($found) {
  &tab_start;
  print "<p>   IP $thisIP  .</p>";
  print "<p>  : $your</p>";
  print "<p>    : $max</p>";
  open (DATA, "$datafolder/$name/$name.txt");
  @data = <DATA>;
  close (DATA);
  $all=0;  
  for ($i=2; $i<=$#data; $i+=1) {
   chomp ($data[$i]);
   if ($data[$i] eq "") {
    ($text,$picture,$vars)=split(/\|/, $data[$i+1]);
    $max=0;
    for ($j=0; $j<$vars; $j+=1) {
     ($text,$ball)=split(/\|/, $data[$i+2+$j]);
     if ($ball > $max) { $max = $ball; } 
    }
    $all += $max;
   }
  }
  print "<p>   : $all</p>";
  if ($all>0) {
   $ball = ($your * 5) / $all;
   $per = ($your * 100) / $all;
   print "<p>     : $per</p>";
   if ($ball < 2) { $ball = 2; }
   elsif ($ball > 5) { $ball = "5+"; }
   elsif (($ball >=2) and ($ball<2.5)) { $ball = 2; }
   elsif (($ball >=2.5) and ($ball<3.5)) { $ball = 3; }
   elsif (($ball >=3.5) and ($ball<4.5)) { $ball = 4; }
   else { $ball =5; }
   print "<p> : <font color=red><big><b>$ball</b></big></font></p>";
  }
  print "<p>          .</p>";
  &tab_end;
 }
 else {
  &tab_start;
  print "<p>   IP $thisIP     !   </p>";
  &tab_end;
 }
# &linktoback;
}
